/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package client.logger;

import io.ScoreIO;

import java.io.File;
import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Observable;
import java.util.TreeMap;
import java.util.concurrent.ConcurrentHashMap;

import server.ABServer;
import client.logger.comparator.ValueComparator;


public class PlayerInfo extends Observable implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 94961452126424256L;
	private ConcurrentHashMap<Integer,Configuration> players_Info;
	
	public ConcurrentHashMap<Integer, Configuration> getPlayers_Info() {
		return players_Info;
	}
	public PlayerInfo()
	{
		players_Info = new ConcurrentHashMap<Integer,Configuration>();
		
	}
	public synchronized Configuration reterieveConf(int player_id)
	{
		return players_Info.get(player_id);
	}
	public synchronized boolean configure(int player_id)
	{
		//if round = 2, load their level score;
		
		if(!players_Info.containsKey(player_id))
		{
			LinkedHashMap<Integer, Integer> score = new LinkedHashMap<Integer, Integer>();
			for (int i = 0; i < ABServer.maxLevelNum; i++)
				score.put(i + 1, 0);
			//players_Info.put(player_id, new Configuration(player_id, 1, new LinkedHashMap<Integer,Integer>()));
			players_Info.put(player_id, new Configuration(player_id, 1, score));
			//createPlayerFiles(player_id);
			this.setChanged();
			this.notifyObservers();
	
		    
		}
		//System.out.println("############# " + ABServer.round);
/*		if(ABServer.round == 2)
		{
			
			Configuration conf = players_Info.get(player_id);
			System.out.println(" load scores for " + player_id);
			if(conf != null){
			HashMap<Integer, Integer> scores = conf.getScore();
			String dir = player_id+"score";
			int[] score = ScoreIO.loadScore(dir);
			int totalscore = 0;
			for(int i = 0; i < score.length; i ++ )
			{
				scores.put((i + 1),score[i]);
				totalscore += score[i];
			}
			conf.setTotalScore(totalscore);			
			
		}
		}*/
		
		if (ABServer.isLoadPlayerScore()) //use last round score, if any
		{
			Configuration conf = players_Info.get(player_id);
			File file = new File(String.format(ABServer.teamScoreFnameFormat, player_id, ABServer.round - 1));
			int[] scoreArr = ScoreIO.loadScore(file);
			int total = 0;
			for (int i = 0; i < scoreArr.length; i++)
			{
				conf.getScore().put(i + 1, scoreArr[i]);
				total += scoreArr[i];
			}
			conf.setTotalScore(total);
					
		}
		return true;
	

	}
/*	private synchronized void createPlayerFiles(int player_id)
	{
		File file = new File(System.getProperty("user.dir") + Env.getSystemSeparator()+player_id);
		File _file = new File( System.getProperty("user.dir") + Env.getSystemSeparator()+player_id + Env.getSystemSeparator() + "screenshots");
		Configuration conf = players_Info.get(player_id);
	
		//System.out.println("createPlayerFiles for " + player_id + " directory: " + file.getAbsolutePath());
		
		 * Enable the comment when developing loggers
		 * if(!file.isDirectory())
		{
			file.mkdir();
			_file.mkdirs();
			System.out.println(" make directories ");
		   
		}
		
	}*/
	public String toString_DescendingOrder()
	{
		StringBuilder player_info = new StringBuilder();
		//sort the hash map
		Map<Integer,Configuration> map = MapSort.sortByValue(players_Info);
		for (int team_id: map.keySet()){
			Configuration conf = players_Info.get(team_id);
    		player_info.append(conf + "\n");
		}
		return player_info.toString();
	}

    @Override
	public String toString()
    {
    	StringBuilder player_info = new StringBuilder();
    	for(int team_id: players_Info.keySet())
    	{
    		Configuration conf = players_Info.get(team_id);
    		player_info.append(conf + "\n");
    	}
    	return player_info.toString();
    }
    static class MapSort {
    	 
    	  public static Map<Integer,Configuration> sortByValue(Map<Integer,Configuration> unsortedMap){
    		 Map<Integer,Configuration> sortedMap = new TreeMap<Integer,Configuration>(new ValueComparator(unsortedMap));
    	    sortedMap.putAll(unsortedMap);
    	    return sortedMap;
    	  }
    	
  
}
}
