/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package gui;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import server.ABServer;
import server.ABServerManager;

public class ControlPanel implements Runnable{

	private static JFrame frame;
	private static JLabel[] agentLabels;
	private static JLabel[] connectionLabels;
	private static JLabel[] teamIDLabels;
	private static JButton[] pairButtons;
	private static HashMap<Long, Integer> entry_map;
	private static LinkedList<Integer> availableEntry;
	private static JButton startButton;
	private static JButton reconnectButton;
	protected Timer timer, termi_timer;  
	public JFrame getFrame() {
		return frame;
	}

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					new ControlPanel();
					ControlPanel.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public ControlPanel() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		String lookandFeel = UIManager.getSystemLookAndFeelClassName();
	
		try {
			UIManager.setLookAndFeel(lookandFeel);
		} catch (ClassNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (InstantiationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IllegalAccessException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (UnsupportedLookAndFeelException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		entry_map = new HashMap<Long, Integer>();
		availableEntry = new LinkedList<Integer>();
		for (int i = 0; i < 8; i++)
		{
			availableEntry.add(i);
		}
		frame = new JFrame();
		frame.setTitle("Server Control Panel");
		frame.setBounds(100, 100, 450, 500);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		startButton = new JButton("Start");
		
		startButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) 
			{
				for (Integer i = 0; i < pairButtons.length; i++){	
					pairButtons[i].setEnabled(false);
				}
				ABServerManager.startTheCompetition();
				startButton.setEnabled(false);
				reconnectButton.setEnabled(true);
				timer = new Timer();
				timer.scheduleAtFixedRate(new TimerTask() {
			            int time_limit = ABServer.time_limit * 60;
			            int mins = time_limit / 60;
			            int secs = time_limit % 60;
			            public void run() {
			            	time_limit --;
			    	        mins = time_limit / 60;
			    	        secs = time_limit % 60;
			    	        frame.setTitle("Remaining Time: "+ mins + ":" + secs );
			                if (time_limit < 0)
			                 {
			                	timer.cancel();
			                	termi_timer = new Timer();
			                	termi_timer.scheduleAtFixedRate(new TimerTask() {
			                		int time_limit = 180;
			                		int mins = time_limit / 60;
			 			            int secs = time_limit % 60;
									public void run() {
										time_limit --;
						    	        mins = time_limit / 60;
						    	        secs = time_limit % 60;
						    	        frame.setTitle("Terminating : "+ mins + ":" + secs );
										if (time_limit < 0)
										{
											termi_timer.cancel();
											frame.setTitle("Server Control Panel");
										}
									}
			                		
			                	}, 0, 1000);
			                 }
			            }
			        }, 0, 1000);
			
			}
			
		});
		
		pairButtons = new JButton[8];
		for (Integer i = 0; i < pairButtons.length; i++){	
			pairButtons[i] = new JButton("pair "+ (i+1));
			pairButtons[i].setName(Integer.toString(i+1));
			pairButtons[i].setFont(new Font("Serif", Font.PLAIN, 16));
			pairButtons[i].setEnabled(false);
			pairButtons[i].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					JButton source = ((JButton)e.getSource());
					String source_name = source.getName();
					boolean is_pair = source.getText().contains("pair");
					if (is_pair) {
						System.out.println("hello");
						for (Integer i = 0; i < pairButtons.length; i++){
							if (!source_name.equals(pairButtons[i].getName()) && pairButtons[i].isEnabled()) {
								pairButtons[i].setText("with me " + (i+1));
							}
						}
					} else {
						for (Integer i = 0; i < pairButtons.length; i++){
							if (pairButtons[i].getText().contains("pair")) {
								source.setEnabled(false);
								source.setText("me and " + (i+1));
								pairButtons[i].setEnabled(false);
								pairButtons[i].setText("me and " + source_name);
								ABServerManager.pair((i+1), Integer.parseInt(source_name));
								break;
							}
						}
						for (Integer i = 0; i < pairButtons.length; i++){
							if (pairButtons[i].getText().contains("with")) {
								pairButtons[i].setText("pair " + (i+1));
							}
						}
						
					}
				
				}
				
			});
		}
		
		agentLabels = new JLabel[8];
		for (int i = 0; i < agentLabels.length; i++){
			agentLabels[i] = new JLabel("Agent "+ (i+1) +" :");
			agentLabels[i].setFont(new Font("Serif", Font.PLAIN, 16));
		}
		
		JLabel lblConnection = new JLabel("Status:");
		lblConnection.setFont(new Font("Serif", Font.PLAIN, 16));
		JLabel lblTeamId = new JLabel("Team ID:");
		lblTeamId.setFont(new Font("Serif", Font.PLAIN, 16));
		
		connectionLabels = new JLabel[8];
		teamIDLabels = new JLabel[8];
		JButton optionButton = new JButton("Save");
		optionButton.setEnabled(true);
		optionButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//run back up
				try {
					
					BufferedWriter buos = new BufferedWriter(new FileWriter("./DB/Temp_workgroup_"+ ABServer.current_group ));
					//buos.append(player_info.toString());
					buos.write("==============  Group ==========================\n");
					buos.append(ABServer.player_info.toString_DescendingOrder());
					buos.append(" Time elapsed: " + (System.currentTimeMillis() - ABServerManager.current_time)/1000 + "secs" );
					buos.append("============= Group End ======================\n");
					buos.close();
					System.out.println(" The Server State has been backed up");
				} catch (FileNotFoundException e2) {
					System.out.println("ServerBackup not found");
				} catch (IOException e1) {
					System.out.println(" fail to write the server state");
				}
			}
		});
		reconnectButton = new JButton("Recon");
		reconnectButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				ABServerManager.reconnect();
			}
		});
		resetAll();
		GroupLayout groupLayout = new GroupLayout(frame.getContentPane());
	
		
		groupLayout.setHorizontalGroup(
				groupLayout.createParallelGroup(Alignment.LEADING)
					.addGroup(groupLayout.createSequentialGroup()
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
							.addGroup(groupLayout.createSequentialGroup()
								.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
									.addComponent(agentLabels[7])
									.addComponent(agentLabels[6])
									.addComponent(agentLabels[5])
									.addComponent(agentLabels[4])
									.addComponent(agentLabels[3])
									.addComponent(agentLabels[2])
									.addComponent(agentLabels[1])
									.addComponent(agentLabels[0]))
								.addGap(25)
								.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(pairButtons[7])
										.addComponent(pairButtons[6])
										.addComponent(pairButtons[5])
										.addComponent(pairButtons[4])
										.addComponent(pairButtons[3])
										.addComponent(pairButtons[2])
										.addComponent(pairButtons[1])
										.addComponent(pairButtons[0]))
								.addGap(25)
								.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
									.addComponent(lblConnection)
									.addComponent(connectionLabels[0])
									.addComponent(connectionLabels[1], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[2], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[3], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[4], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[5], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[6], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(connectionLabels[7], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE))
								.addGap(46)
								.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
									.addComponent(teamIDLabels[0], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[7], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[6], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[5], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[4], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[3], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[2], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(teamIDLabels[1], GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
									.addComponent(lblTeamId)))
							.addGroup(groupLayout.createSequentialGroup()
								.addComponent(startButton, GroupLayout.PREFERRED_SIZE, 69, GroupLayout.PREFERRED_SIZE)
								.addPreferredGap(ComponentPlacement.UNRELATED)
								.addComponent(reconnectButton, GroupLayout.PREFERRED_SIZE, 74, GroupLayout.PREFERRED_SIZE)
								.addPreferredGap(ComponentPlacement.UNRELATED)
								.addComponent(optionButton)))
						.addContainerGap(103, Short.MAX_VALUE))
			);
			groupLayout.setVerticalGroup(
				groupLayout.createParallelGroup(Alignment.LEADING)
					.addGroup(groupLayout.createSequentialGroup()
						.addGap(5)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(lblConnection)
							.addComponent(lblTeamId))
						.addPreferredGap(ComponentPlacement.RELATED)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[0])
							.addComponent(pairButtons[0])
							.addComponent(connectionLabels[0])
							.addComponent(teamIDLabels[0]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[1])
							.addComponent(pairButtons[1])
							.addComponent(connectionLabels[1])
							.addComponent(teamIDLabels[1]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[2])
							.addComponent(pairButtons[2])
							.addComponent(connectionLabels[2])
							.addComponent(teamIDLabels[2]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[3])
							.addComponent(pairButtons[3])
							.addComponent(connectionLabels[3])
							.addComponent(teamIDLabels[3]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[4])
							.addComponent(pairButtons[4])
							.addComponent(connectionLabels[4])
							.addComponent(teamIDLabels[4]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[5])
							.addComponent(pairButtons[5])
							.addComponent(connectionLabels[5])
							.addComponent(teamIDLabels[5]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[6])
							.addComponent(pairButtons[6])
							.addComponent(connectionLabels[6])
							.addComponent(teamIDLabels[6]))
						.addGap(18)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(agentLabels[7])
							.addComponent(pairButtons[7])
							.addComponent(connectionLabels[7])
							.addComponent(teamIDLabels[7]))
						.addPreferredGap(ComponentPlacement.RELATED, 33, Short.MAX_VALUE)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addComponent(startButton)
							.addComponent(reconnectButton)
							.addComponent(optionButton))
						.addGap(21))
			);
		frame.getContentPane().setLayout(groupLayout);
	}
	private static Integer getNextAvailableSlot()
	{
		Integer id = availableEntry.poll();
		if(id == null)
			id = -1;
		return id;
	}
	public synchronized static void returnAvailableSlot(long threadID)
	{
		Integer id = entry_map.get(threadID);
		if(id != null)
		{	
			availableEntry.add(id);
			entry_map.remove(threadID);
		}
		connectionLabels[id].setText("Waiting");
		connectionLabels[id].setForeground(Color.black);
		teamIDLabels[id].setText("TBA");
		frame.repaint();
	}
	public static synchronized void setEntry(long threadID, String connection_status)
	{
		//System.out.println("Debug setEntry: " + threadID);
		if (entry_map.containsKey(threadID))
		{
			//update 
			int id = entry_map.get(threadID);
			if(id != -1)
			{
				
				connectionLabels[id].setText(connection_status);
				if(connection_status.equalsIgnoreCase("Connected")) {
					pairButtons[id].setEnabled(true);
					connectionLabels[id].setForeground(Color.ORANGE);
				}
				else if(connection_status.equalsIgnoreCase("Running")) {
						connectionLabels[id].setText(connection_status);
						connectionLabels[id].setForeground(Color.GREEN);
				}
				//teamIDLabels[id].setText(threadID + "");
			}
		}
		else {
			int id = getNextAvailableSlot();
			//System.out.println("Debug setEntry get id: " + id);
			if(id != -1)
			{
				connectionLabels[id].setText(connection_status);
				System.out.println(" set connection status: " + connection_status);
				if(connection_status.equalsIgnoreCase("connected")) {
					pairButtons[id].setEnabled(true);
					connectionLabels[id].setForeground(Color.ORANGE);
				}
				else if(connection_status.equalsIgnoreCase("running")) {
					connectionLabels[id].setText(connection_status);
					connectionLabels[id].setForeground(Color.GREEN);
				}
				entry_map.put(threadID, id);
				
			}
		}
	
		frame.repaint();
		
	}
	public static void resetAndRepaint()
	{
		resetAll();
		frame.repaint();
	}
	public static void updateTeamId(long threadId, int teamId)
	{
		int id = entry_map.get(threadId);
		teamIDLabels[id].setText("" + teamId);
		frame.repaint();
	}
	private static void resetAll()
	{
		
	  for(int i = 0; i < connectionLabels.length; i++)
	 	{
		  if(connectionLabels[i] == null)
			  connectionLabels[i] = new JLabel("Waiting");
		  connectionLabels[i].setFont(new Font("Serif", Font.PLAIN, 16));
	 	}
		
	  for(int i = 0; i < teamIDLabels.length; i++)
	 	{
		  if(teamIDLabels[i] == null)
			  teamIDLabels[i] = new JLabel("TBA");
		  teamIDLabels[i].setFont(new Font("Serif", Font.PLAIN, 16));
	 	}
	   startButton.setEnabled(true);
	   reconnectButton.setEnabled(false);
	  
		
		
		
	
	}
	@Override
	public void run() {
		
		
	}
	


	

}
