/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package proxy;


public class FIFORequestSchedule extends RequestSchedule{
	
	private Proxy proxy;

	@Override
	public void run() {
		
		while (true)
		{
			getNextResult();
		}
	}

	@Override
	protected void getNextResult() {
		
		for (AgentRequestHandler handler : handlers )
		{
			//process request one by one
			if(handler.waiting){
				try {
					handler.result.put(proxy.send(handler.chrome_window, handler.message));
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				handler.waiting = false;
			}
		}
		
	}
	

	
}
