/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package server;

import org.java_websocket.WebSocket;

import vision.GameStateExtractor.GameState;



public class AgentThread extends Thread {

	private Agent agent;
	private boolean running = false;
	
	public boolean isRunning() {
		return running;
	}

	public AgentThread(Agent agent) {
		super(agent);
		this.agent = agent;

	}
	
	public void runAgent()
	{
		running = true;
		agent.stopWait();

	}

	public void terminateAgent()
	{
		agent.aboutToTerminate();
		
		if(!ABServer.NO_ABOUT_TO_TERMINATE)
		for (int i = 0; i < 6; i++)
		{
			try {
			// wait 30 * 6 = 180 seconds then terminate the agent;
			Thread.sleep(30000);
			
			System.out.println(((i+1)*30) + " secs..");
			} catch (InterruptedException e) {
			
			e.printStackTrace();
		}
			}
		agent.terminate(true);
		
	}

	public int getBid() {
		return agent.getBid();
	}

	public void setTurn(boolean b) {
		agent.setTurn(b);
		
	}

	public boolean getTurn() {
		return agent.getTurn();
	}

	public boolean hasChromeWindow() {
		return agent.getChrome_window() != null;
	}

	public WebSocket getChromeWindow() {
		return agent.getChrome_window();
	}

	public void setChromeWindow(WebSocket chromeWindow) {
		agent.setChromeWindow(chromeWindow);
		agent.stopWaitForPartner();
	}
	
	public boolean loadLevel(Integer level) {
		return agent.loadLevel(level);
	}
	
	public void GoToLevelSelectionPage () {
		agent.GoToLevelSelectionPage();
	}

	public int checkCurrentScoreSafemode() {
		return agent.checkCurrentScoreSafemode();
	}

	public GameState getGameState() {
		return agent.getGameState();
	}
	
	public long getLastShotTime() {
		return agent.getLastShotTime();
	}

	public void setGame(Game game) {
		agent.setGame(game);
	}

	public boolean has_bid() {
		return agent.has_bid();
	}
	
	public void new_bid() {
		agent.new_bid();
	}
	
	public boolean same_agent(Agent agent2) {
		return agent == agent2;
	}

	public void wasteBird() {
		agent.wasteBird();
	}


}
