/*****************************************************************************
 ** ANGRYBIRDS AI AGENT FRAMEWORK
 ** Copyright (c) 2015, XiaoYu (Gary) Ge, Jochen Renz,Stephen Gould,
 **  Sahan Abeyasinghe,Jim Keys, Rohan Verma, Andrew Wang, Peng Zhang
 ** All rights reserved.
**This work is licensed under the terms of the GNU Affero General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
**To view a copy of this license, visit http://www.gnu.org/licenses/
 *****************************************************************************/

package server.schema;

import org.java_websocket.WebSocket;

import client.logger.Configuration;

import proxy.Proxy;
import proxy.message.ProxyClickMessage;
import proxy.message.ProxyMouseWheelMessage;

import server.Agent;
import server.util.StateUtil;
import vision.GameStateExtractor.GameState;

public class RestartLevelSchema {
private Proxy server;
private Configuration conf;
private WebSocket chrome_window;
private StateUtil stateUtil;
public RestartLevelSchema(Agent agent)
{
	this.server = agent.getAgentProxy();
	this.conf = agent.getCurrentConfiguration();
	this.chrome_window = agent.getChrome_window();
	stateUtil = agent.getStateUtil();
	}
public boolean restartLevel()
{
	
	   int current_level = conf.getCurrent_level();
	   GameState state = stateUtil.checkCurrentState();
	   //System.out.println("restart the level (playing)" + state);
	if(state == GameState.WON || state == GameState.LOST)
	{
		server.send(chrome_window, new ProxyClickMessage(420,380));//Click the left most button at the end page
		//System.out.println(" restart the level ");
		  try {
				Thread.sleep(2000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
	}
	else if(state == GameState.PLAYING)
	{
		 
			server.send(chrome_window, new ProxyClickMessage(100,31));
			  try {
					Thread.sleep(1000);
				} catch (InterruptedException e1) {
					e1.printStackTrace();
				}
	}
	  //Wait 4000 seconds for loading the level
	   try {
			Thread.sleep(4000);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	   //Zooming out
	   //System.out.println("Zooming out");
	   for (int k = 0; k < 15; k++) 
	   {
	   server.send(chrome_window,new ProxyMouseWheelMessage(-1));
	   }
	   try {
			Thread.sleep(2000);
		} catch (InterruptedException e1) {
			
			e1.printStackTrace();
		}
	   conf.setCurrent_level(current_level);
	   //conf.increaseRun();
	   //BenchmarkLoggerManager.getLogger(conf.getPlayer_id()).run(current_level);
	   return true;

}
}
